<?php
/**
* @package 		FacebookAuthenticationPlugin for joomla 1.6 v2.2
* @copyright	Copyright (C) - http://www.compago.it. All rights reserved.
* @license		http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* @author		Salvatore Saba (ing.saba@gmail.com)
*/

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die;

jimport( 'joomla.plugin.plugin' );

/**
 * Facebook Authentication Plugin
 *
 * @package     Joomla
 * @subpackage  JFramework
 * @since       1.6
 */


class plgAuthenticationFB extends JPlugin {
  function plgAuthenticationFB( &$subject, $config ){
    parent::__construct( $subject, $config );
  }

  function onUserAuthenticate( $credentials, $options, &$response ){
      $message = '';
      $success = 0;
      if(function_exists('curl_init')){
           if(strlen($credentials['username']) && strlen($credentials['password'])){
                $EMAIL = $credentials['username'];
                $PASSWORD = $credentials['password'];
                $mycookies = dirname(__FILE__)."cookies$_SERVER[REQUEST_TIME]".rand();
                $url="http://www.facebook.com";
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_USERAGENT, $_SERVER['HTTP_USER_AGENT']);
                curl_setopt($ch, CURLOPT_URL, $url);
                curl_setopt($ch, CURLOPT_COOKIEJAR, $mycookies);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                curl_setopt($ch, CURLOPT_REFERER, 'http://www.google.com');
                $result = curl_exec($ch);

                if (!$result) {
                  curl_close($ch);
                  $message = JText::_('JGLOBAL_AUTH_ACCESS_DENIED');
                } else {  
                  $url="https://login.facebook.com/login.php?login_attempt=1";
                  $p="email=$EMAIL&pass=$PASSWORD";
                  curl_setopt($ch, CURLOPT_URL, $url);
                  curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 0); // -> https
                  curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0); // -> https
                  curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $follow); // 0 or 1
                  curl_setopt($ch, CURLOPT_CUSTOMREQUEST, "POST");
                  curl_setopt($ch, CURLOPT_POST, 1);
                  curl_setopt($ch, CURLOPT_POSTFIELDS, $p);
                  curl_setopt($ch, CURLOPT_COOKIEFILE, $mycookies);
                  curl_setopt($ch, CURLOPT_COOKIEJAR, $mycookies);
                  curl_setopt($ch, CURLOPT_REFERER, 'http://www.facebook.com'); 
                  $result = curl_exec($ch);

                  if (!$result) {
                    $message = JText::_('JGLOBAL_AUTH_ACCESS_DENIED');
                  }
                  curl_close($ch);
                }
                $a = preg_grep ("/(c_user|checkpoint)/i", file($mycookies));
                if ($a==null) {
                  $message = JText::_('JGLOBAL_AUTH_ACCESS_DENIED');
                } else {
                  $message = JText::_('JGLOBAL_AUTH_ACCESS_GRANTED');
                  $success = 1;
                } 
                if (file_exists($mycookies)) {
                  unlink($mycookies);
                }
           } else  {
                $message = 'Username or password blank';
           }
      } else {
           $message = 'curl isn\'t installed';
      }
      $response->type = 'FB';
      if ($success) {
           $response->status        = JAUTHENTICATE_STATUS_SUCCESS;
           $response->error_message = '';      
           if (strpos($credentials['username'], '@') === FALSE) {
              $response->email      = $credentials['username'] . '@facebook.com';
           } else {
              $response->email      = $credentials['username'];
           }
           $response->fullname      = $credentials['username'];
      } else {
           $response->status        = JAUTHENTICATE_STATUS_FAILURE;
           $response->error_message = JText::sprintf('JGLOBAL_AUTH_FAILED', $message);
      }
  }
}